ATK_INTER
#ifndef _atomlist_H_
#define _atomlist_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 


#include <atom.H>

struct atoms 
{
    class atom *atom;
    struct atoms *next;
};

#include <ATK.H>

class atomlist : public ATK  {
public:
	virtual ATKregistryEntry *ATKregistry();


  virtual class atom * Last()  ;
    virtual short Memberp(class atom *list)  ;
  virtual void DropFirst();
    virtual void Prepend(class atom *newitem);
    virtual void Append(class atom *newitem);
    virtual void JoinToEnd(class atomlist *otherlist);
    virtual void JoinToBeginning(class atomlist *otherlist);
    virtual void Cut(struct atoms *mark);

    inline struct atoms * TraversalStart() { return (this->atoms); }
    inline struct atoms * TraversalNext(struct atoms *loc)  
            { return ((loc) == NULL ? NULL : (loc)->next); }
    inline class atom * TraversalAtom(struct atoms *loc)  
            { return ((loc) == NULL ? NULL : (loc)->atom); }
    inline class atom * First() { return (this->atoms != NULL ? this->atoms->atom : NULL); }
    inline struct atoms * Mark() { return (this->atoms); }

    
	atomlist();
    
	virtual ~atomlist();
    static class atomlist * Copy(class atomlist *oldlist)  ;
    static class atomlist * StringToAtomlist(const char *string)  ;
    

    struct atoms *atoms;
};

#endif /* _atomlist_H_ */
