ATK_INTER
#ifndef _fnotev_H_
#define _fnotev_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/




#include <view.H>

class fnotev: public  view {
  public:
    virtual ATKregistryEntry *ATKregistry();
    fnotev();
    virtual ~fnotev();

    void FullUpdate(enum view_UpdateType type, long left, long top, long width, long right);
    void Update();
    class view * Hit (enum view_MouseAction action, long x, long y, long numberOfClicks)  ;
    void ObservedChanged (class observable *changed, long value);
    view_DSattributes DesiredSize(long width, long height, enum view_DSpass pass, long *dWidth, long *dheight)  ;
    void LinkTree(class view *parent);
    void GetOrigin(long width, long height, long *originX, long *originY);
    void Print(FILE *file, char *processor, char *finalFormat, boolean topLevel);
    void ReceiveInputFocus();
    boolean RecSearch(struct SearchPattern *pat, boolean toplevel);
    boolean RecSrchResume(struct SearchPattern *pat);
    void *GetPSPrintInterface(char *printtype);

    virtual void pushchild();
    virtual void popchild();

    inline void SetDisplayStr(char *S) { ((this)->displaystr = (S)); }
    inline class textview * GetParentTextview() { return ((this)->parentview); }
    inline class text * GetParentText() { return ((this)->parenttext); }

    static void SetEndnote(boolean doendnotes);

    static boolean InitializeClass();

    struct impair *imp;
    class fontdesc *fd,*ofd;
    class cursor *cursor;
    int fnotetype;
    class text *parenttext;
    class textview *parentview;
    char *displaystr;
    struct  fontdesc_charInfo *ci;
};


#endif /* _fnotev_H_ */
