ATK_INTER
#ifndef _hash_H_
#define _hash_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 

/* A hash table
 *
 */

#define hash_BUCKETS 32

#include <ATK.H>
#include <glist.H>
	typedef void (*hash_freefptr)(char *val);
	typedef int (*hash_hashfptr)(char *n);

class hash : public ATK  {
public:
	virtual ATKregistryEntry *ATKregistry();

    
	hash();
    
	virtual ~hash();
    
	static boolean InitializeClass();


    virtual char * Lookup(char *key)  ;
    virtual void Store(char *key, char *value);
    virtual char * Delete(char *key)  ;
    virtual char * Rename(char *key, char *new_c)  ;
    virtual void Clear(hash_freefptr valFree);
    virtual void Debug();

    inline void SetHash(hash_hashfptr fn) { (this->hashfunc = (fn)); }

    class glist *buckets[hash_BUCKETS];
    hash_hashfptr hashfunc;
};

#endif /* _hash_H_ */
